// The returned value is stored in the global var strbuf
// takes a string of the form commandNumber and analyse it
// return values:  1-3,10 just display current settings
//                 99 values upated
//
int8_t analyse_get_url(char *str)
{  
  if (strncmp("config", str, 6) != 0 && strncmp("link_", str, 5) != 0) {
    return(-1);
  }
  if (find_key_val(str, "fd") == 0) {
    if (strncmp("link_tim", str, 8) == 0) {
      // just display Time Config
      return(21);
    } else if (strncmp("link_dat", str, 8) == 0) {
      // just display Date Config
      return(22);
    } else if (strncmp("link_dis", str, 8) == 0) {
      // just display Display Config
      return(23);
    } else if (strncmp("link_net", str, 8) == 0) {
      // just display Network Config
      return(24);
    } else if (strncmp("link_ntp", str, 8) == 0) {
      // just display NTP Config
      return(25);
    } else if (strncmp("link_env", str, 8) == 0) {
      // just display LED Config
      return(26);
    } else if (strncmp("link_led", str, 8) == 0) {
      // just display LED Config
      return(27);
    } else if (strncmp("config", str, 6) == 0) {
      // just ALL-Config MainDisp
      return(10);
    }
  }
  //now store the values.
  if (find_key_val(str, "DISP")) {
    es.ES_urldecode(strbuf);
    clock_disp = atoi(strbuf);
    if (clock_disp) {
      lc.shutdown( 0, false ) ;
    } else {
      lc.shutdown( 0, true );
    }
    lcd_needs_update == 99;
  }
  if (find_key_val(str, "AP")) {
    es.ES_urldecode(strbuf);
    ampm = atoi(strbuf);
  }
  if (find_key_val(str, "DDI")) {
    es.ES_urldecode(strbuf);
    int16_t n = atoi(strbuf);
    if ( n >= 0 && n <= 1440 ) {
      date_disp_int = atoi(strbuf);
    } else {
      return(95); // Error
    }
  }
  if (find_key_val(str, "DDS")) {
    es.ES_urldecode(strbuf);
    int8_t n = atoi(strbuf);
    if ( n >= 0 && n <= 60 ) {
      date_disp_sec = atoi(strbuf);
      if ( date_disp_int >= 0 && date_disp_sec == 60 ) {
        SEL_CAT = true;
      }
      lcd_needs_update = 99;
    } else {
      return(95); // Error
    }
  }
  if (find_key_val(str, "CD")) {
    es.ES_urldecode(strbuf);
    colon_disp = atoi(strbuf);
  }
  if (find_key_val(str, "DTS")) {
    int8_t n = atoi(strbuf);
    if ( n >= 0 && n <= 24 ) {
      day_time_start = atoi(strbuf);
    } else {
      return(95); // Error
    }
  }
  if (find_key_val(str, "DTE")) {
    int8_t n = atoi(strbuf);
    if ( n >= 0 && n <= 24 ) {
      day_time_end = atoi(strbuf);
    } else {
      return(95); // Error
    }
  }
  if (find_key_val(str, "DB")) {
    es.ES_urldecode(strbuf);
    int8_t n = atoi(strbuf);
    if ( n < 0 ) {
      n = 0;
    } else if ( n >= 16 ){
      n = 15;
    }
    //if ( n >= 0 && n < 16 ) {
      day_brightness = atoi(strbuf);
    //}
  }
  if (find_key_val(str, "DM")) {
    es.ES_urldecode(strbuf);
    dimmer = atoi(strbuf);
  }
  if (find_key_val(str, "NM")) {
    es.ES_urldecode(strbuf);
    night_mode = atoi(strbuf);
  }
  if (find_key_val(str, "NB")) {
    es.ES_urldecode(strbuf);
    int8_t n = atoi(strbuf);
    if ( n < 0 ) {
      n = 0;
    } else if ( n >= 16 ){
      n = 15;
    }
    //if ( n >= 0 && n < 16 ) {
      night_brightness = atoi(strbuf);
    //}
  }
  /*if (find_key_val(str, "NET")) {
    es.ES_urldecode(strbuf);
    network = atoi(strbuf);
  }*/
  if (find_key_val(str, "DHCP")) {
    es.ES_urldecode(strbuf);
    dhcp = atoi(strbuf);
    
  }
  if (find_key_val(str, "IP")) {
    str2ip(ip_address,strbuf);
  }
  if (find_key_val(str, "SN")) {
    str2ip(netmask,strbuf);
  }
  if (find_key_val(str, "GW")) {
    str2ip(gw_addrsss, strbuf);
  }
  if (find_key_val(str, "NS")) {
    str2ip(dns_address, strbuf);
  }
  if (find_key_val(str, "NTP")) {
    es.ES_urldecode(strbuf);
    ntp = atoi(strbuf);
  }
  if (find_key_val(str, "NTA")) {
    if (!str2ip(ntp_polling_address,strbuf)) {
      strcpy( dnsreqesthost, strbuf );
      dns_state=0;  // Request DNS
    }
  }
  if (find_key_val(str, "NTI")) {
    es.ES_urldecode(strbuf);
    uint8_t n = atoi(strbuf);
    if ( n > 0 && n < 255 ) {
      ntp_interval = atoi(strbuf);
    }
  }
  if (find_key_val(str, "TZ")) {
    es.ES_urldecode(strbuf);
    deldot(strbuf);
    int16_t n = atoi(strbuf);
    if ( n > -140 && n < 140 ) {
      hours_offset_to_utc = atoi(strbuf);
      lcd_needs_update = 128;
    } else {
      return(95); // Error
    }
  }
  /*if (find_key_val(str, "TD")) {
    es.ES_urldecode(strbuf);
    temp_disp = atoi(strbuf);
  }*/
  if (find_key_val(str, "TCF")) {
    es.ES_urldecode(strbuf);
    cefa = atoi(strbuf);
  }
  if (find_key_val(str, "LM")) {
    es.ES_urldecode(strbuf);
    int8_t n = atoi(strbuf);
    if ( n >= 0 && n < 5 ) {
      LED_mode = atoi(strbuf);
    }
  }
  if (find_key_val(str, "LCS")) {
    es.ES_urldecode(strbuf);
    int8_t n = atoi(strbuf);
    if ( n >= 0 && n < 2 ) {
      RGB_change_speed = atoi(strbuf);
    }
  }
  if (find_key_val(str, "LR")) {
    es.ES_urldecode(strbuf);
    uint8_t n = atoi(strbuf);
    if ( n >= 0 && n < 256 ) {
      LED_red = atoi(strbuf);
    } else {
      return(95); // Error
    }
  }
  if (find_key_val(str, "LG")) {
    es.ES_urldecode(strbuf);
    uint8_t n = atoi(strbuf);
    if ( n >= 0 && n < 256 ) {
      LED_green = atoi(strbuf);
    } else {
      return(95); // Error
    }
  }
  if (find_key_val(str, "LB")) {
    es.ES_urldecode(strbuf);
    uint8_t n = atoi(strbuf);
    if ( n >= 0 && n < 256 ) {
      LED_blue = atoi(strbuf);
    } else {
      return(95); // Error
    }
  }
  /*if (find_key_val(str, "LTS")) {
    int8_t n = atoi(strbuf);
    if ( n >= 0 && n <= 24 ) {
      LED_light_time_start = atoi(strbuf);
    } else {
      return(95); // Error
    }
  }
  if (find_key_val(str, "LTE")) {
    int8_t n = atoi(strbuf);
    if ( n >= 0 && n <= 24 ) {
      LED_light_time_end = atoi(strbuf);
    } else {
      return(95); // Error
    }
  }*/
  
  // store in eeprom:
  eeprom_busy_wait();
  eeprom_write_byte((uint8_t *)0x0, 60); // magic number
  eeprom_write_block((uint8_t *)ip_address, (void *)1, sizeof(ip_address));
  eeprom_write_block((uint8_t *)netmask, (void *)6, sizeof(netmask));
  eeprom_write_block((uint8_t *)gw_addrsss, (void *)11, sizeof(gw_addrsss));
  eeprom_write_block((uint8_t *)dns_address, (void *)16, sizeof(dns_address));
  eeprom_write_block((uint8_t *)ntp_polling_address, (void *)21, sizeof(ntp_polling_address));
  eeprom_write_byte((uint8_t *)26, hours_offset_to_utc);
  eeprom_write_byte((uint8_t *)27, clock_disp);
  eeprom_write_byte((uint8_t *)28, ampm);
  eeprom_write_byte((uint8_t *)29, date_disp_int >> 8);
  eeprom_write_byte((uint8_t *)30, (date_disp_int << 8) >> 8);
  eeprom_write_byte((uint8_t *)31, date_disp_sec);
  eeprom_write_byte((uint8_t *)32, colon_disp);
  eeprom_write_byte((uint8_t *)33, day_time_start);
  eeprom_write_byte((uint8_t *)34, day_time_end);
  eeprom_write_byte((uint8_t *)35, day_brightness);
  eeprom_write_byte((uint8_t *)36, dimmer);
  eeprom_write_byte((uint8_t *)37, night_mode);
  eeprom_write_byte((uint8_t *)38, night_brightness);
  //eeprom_write_byte((uint8_t *)39, network);
  eeprom_write_byte((uint8_t *)40, dhcp);
  eeprom_write_byte((uint8_t *)41, ntp);
  eeprom_write_byte((uint8_t *)42, ntp_interval);
  //eeprom_write_byte((uint8_t *)43, temp_disp);
  eeprom_write_byte((uint8_t *)44, cefa);
  
  eeprom_write_byte((uint8_t *)50, LED_mode);
  eeprom_write_byte((uint8_t *)51, RGB_change_speed);
  eeprom_write_byte((uint8_t *)52, LED_red);
  eeprom_write_byte((uint8_t *)53, LED_green);
  eeprom_write_byte((uint8_t *)54, LED_blue);
  //eeprom_write_byte((uint8_t *)55, LED_light_time_start);
  //eeprom_write_byte((uint8_t *)56, LED_light_time_end);
  
  return(99); // Ok
}
