// endless loop for main program
void loop()
{
  // Local variable
  static int8_t cmd;
  static int8_t key = -1;
  static int8_t oldkey = -1;
  static uint8_t hol_hour;
  static uint16_t now_min = 0;
  static uint8_t led_num = 0;
  
  uint16_t plen, dat_p;
  
  // Used by DHCP
  boolean gotIp = false;
  long fastDhcpRequest = millis();
  long lastDhcpRequest = fastDhcpRequest;
  
  // Used by DNS
  long lastDnsRequest = 0L;
  
  // Set the brightness
  float avglx[7];
  int8_t lx_in =0;
  int8_t led_bri = day_brightness;
  
  // Data&Time Display and Setup
  static uint64_t gt_time;
  static char date[22];
  static char clock[22];
  static char dstr[4];
  
  static uint8_t set_month, set_day, set_hour, set_min, set_sec, set_week;
  static uint16_t set_year;
  
  // NTP Flag (0 no initial ntp answer, 1= have answer, 2,3=sent new reqest)
  static uint8_t haveNTPanswer = 0;
  static long ntp_response_delay;
  
  // Temperature sensor
  static float reading_t_sensor;
  
  // RGB-LED brightness
  uint8_t Red = 0;
  uint8_t Green = 0;
  uint8_t Blue = 0;
  uint8_t cMap[]={0,0,0};
  long nextLEDChange = millis();
  static uint16_t tmpReadcount = 0;
  static uint16_t cVal  = 0;
  static float tempC = 0;
  static float tempCsum = 0;
  
  while (1) {
    
    key = get_key(); // convert into key press
    
    // Switch Key press
    if ( key != oldkey ) {
      
      // debug print
      /*DEBUG_PRINT("Key:");
      DEBUG_PRINT(key);
      DEBUG_PRINT(" OldKey:");
      DEBUG_PRINTLN(oldkey);
      DEBUG_PRINTLN("Enter keypress");*/
      
      oldkey = key;
      
      if ( key >= 0 ) {
        switch ( key ) {
          case 0:
            // Change 12H/24H mode value
            ampm = !ampm; // Turn over Value
            
            // store in eeprom:
            eeprom_busy_wait();
            //eeprom_write_byte((uint8_t *)0x0, 60); // magic number
            eeprom_write_byte((uint8_t *)28, ampm);
            DEBUG_PRINTLN("12H/24H"); // debug print
            break;
            
          case 1:
            // Change Set mode value
            if ( SET_MODE ) {
              if ( SEL_CAT == 0 ) { set_year = SEL_VAL;
              } else if ( SEL_CAT == 1 ) { set_month = SEL_VAL;
              } else if ( SEL_CAT == 2 ) { set_day = SEL_VAL;
              } else if ( SEL_CAT == 3 ) { set_hour = SEL_VAL;
              } else if ( SEL_CAT == 4 ) { set_min = SEL_VAL;
              } else if ( SEL_CAT == 5 ) { set_sec = SEL_VAL; }
              
              RTC.adjust(DateTime( set_year, set_month, set_day, set_hour, set_min, set_sec));
              
              // Set Indicator
              for ( uint8_t i = 0; i < 7; i++ ) {
                linkstatus[i] = 0;
              }
              nextLEDChange = millis();
              TimeKeep = true;
            } else {
              DateTime now = RTC.now(); // RTC Getting Time
              set_year = now.year() % 100;
              set_month = now.month();
              set_day = now.day();
              set_hour = now.hour();
              set_min = now.minute();
              set_sec = now.second();

              SEL_CAT = 0;
              SEL_VAL = set_year;
            }
            SET_MODE = !SET_MODE; // Turn over Value 
            DEBUG_PRINTLN("SET_MODE"); // debug print
            break;
            
          case 2:
            // Change Select/Date mode value
            if ( SET_MODE ) {
              if ( SEL_CAT < 5 ) {
                SEL_CAT++;
                if ( SEL_CAT == 1 ) {
                  set_year = SEL_VAL;
                  SEL_VAL = set_month;
                } else if ( SEL_CAT == 2 ) {
                  set_month = SEL_VAL;
                  SEL_VAL = set_day;
                } else if ( SEL_CAT == 3 ) {
                  set_day = SEL_VAL;
                  SEL_VAL = set_hour;
                } else if ( SEL_CAT == 4 ) {
                  set_hour = SEL_VAL;
                  SEL_VAL = set_min;
                } else if ( SEL_CAT == 5 ) {
                  set_min = SEL_VAL;
                  SEL_VAL = set_sec;
                }
              } else {
                SEL_CAT = 0;
                set_sec = SEL_VAL;
                SEL_VAL = set_year;
              }
            } else {
              if ( SEL_CAT ) {
                SEL_CAT = false;
              } else {
                SEL_CAT = true;
                //date_disp_int = 0;
                //date_disp_sec = 0;
                lcd_needs_update = 99;
              }
            }
            DEBUG_PRINTLN("Select"); // debug print
            break;
            
          case 3:
            // Change Up/00+ mode value
            if ( SET_MODE ) {
              SEL_VAL++;
              if ( SEL_CAT == 0 && SEL_VAL > 99 ) { //Year
                SEL_VAL = 0;
              } else if ( SEL_CAT == 1 && SEL_VAL > 12 ) { //Month
                SEL_VAL = 0;
              } else if ( SEL_CAT == 2 && SEL_VAL > 31 ) { //Day
                SEL_VAL = 0;
              } else if ( SEL_CAT == 3 && SEL_VAL > 23 ) { //Hour
                SEL_VAL = 0;
              } else { //Minute&Second
                if ( SEL_VAL > 59 ) {
                  SEL_VAL = 0;
                }
              }
            } else {
              // Set "00" seconds(min+)
              RTC.zerosec_p();
              NTP_LED_WaitFlag = false;
              digitalWrite( NTP_LED, LOW );
            }
            DEBUG_PRINTLN("Up Key"); //Debug Print
            break;
            
          case 4:
            // Change Down/00 mode value
            if ( SET_MODE ) {
              SEL_VAL--;
            } else {
              // Set "00" seconds
              RTC.zerosec();
              NTP_LED_WaitFlag = false;
              digitalWrite( NTP_LED, LOW );
            }
            DEBUG_PRINTLN("Dwon key"); //Debug Print
            break;
            
        }
      }
    }
    // SetupMode
    if ( SET_MODE && lcd_needs_update ) {
      
      sprintf_P( date, PSTR("%02u%02u%02u"), set_year, set_month, set_day );
      sprintf_P( clock, PSTR("%02u%02u%02u"), set_hour, set_min, set_sec );
      
      if ( SetBlink ) {
        switch ( SEL_CAT ) {
          case 0:
            sprintf_P( date, PSTR("  %02u%02u"), set_month, set_day );
            break;
          case 1:
            sprintf_P( date, PSTR("%02u  %02u"), set_year, set_day );
            break;
          case 2:
            sprintf_P( date, PSTR("%02u%02u  "), set_year, set_month );
            break;
          case 3:
            sprintf_P( clock, PSTR("  %02u%02u"), set_min, set_sec );
            break;
          case 4:
            sprintf_P( clock, PSTR("%02u  %02u"), set_hour, set_sec );
            break;
          case 5:
            sprintf_P( clock, PSTR("%02u%02u  "), set_hour, set_min );
            break;
        }
      } else {
        switch ( SEL_CAT ) {
          case 0:
            sprintf_P( date, PSTR("%02u%02u%02u"), SEL_VAL, set_month, set_day );
            break;
          case 1:
            sprintf_P( date, PSTR("%02u%02u%02u"), set_year,SEL_VAL , set_day );
            break;
          case 2:
            sprintf_P( date, PSTR("%02u%02u%02u"), set_year, set_month, SEL_VAL );
            break;
          case 3:
            sprintf_P( clock, PSTR("%02u%02u%02u"), SEL_VAL,set_min, set_sec );
            break;
          case 4:
            sprintf_P( clock, PSTR("%02u%02u%02u"), set_hour ,SEL_VAL , set_sec );
            break;
          case 5:
            sprintf_P( clock, PSTR("%02u%02u%02u"), set_hour, set_min ,SEL_VAL );
            break;
        }
      }
      uint8_t led_deg = 5;
      
      for ( uint8_t i = 0; i < 8; i++ ) {
          if ( SEL_CAT < 3 ) {
            lc.setChar( 0, led_deg, date[i], SetBlink );
          } else {
            lc.setChar( 0, led_deg, clock[i], SetBlink );
          }
          led_deg--;
      }
      NTP_LED_WaitFlag = false;
      digitalWrite( NTP_LED, LOW );
      
      // debug print
      /*DEBUG_PRINTLN("SetupMode");
      DEBUG_PRINTLN( date );
      DEBUG_PRINTLN( clock );*/
    }
    
    // read packet, handle ping and wait for a tcp packet:
    plen = es.ES_enc28j60PacketReceive(BUFFER_SIZE, buf);
    //dat_p=es.ES_packetloop_icmp_tcp(buf, es.ES_enc28j60PacketReceive(BUFFER_SIZE, buf));
    
    // In your loop function after receiving a packet, pass it on to be dumped
    /*if (buf[IP_PROTO_P] == IP_PROTO_UDP_V && buf[UDP_SRC_PORT_H_P] == 0 && (buf[UDP_SRC_PORT_L_P] == 0x7b || buf[UDP_SRC_PORT_L_P] == 0x35)) { // NTP Re
      dump.packetDump(buf, plen);
    }*/
    
    // dat_p will be unequal to zero if there is a valid packet data
    dat_p=es.ES_packetloop_icmp_tcp(buf, plen);
    
    // no tcp/udp request & SetupMode
    if( dat_p == 0 && !SET_MODE ) { 
      
      // DHCP Section
      if ( es.ES_enc28j60linkup() ) {
        if ( dhcp ) {
          int retstat = es.ES_check_for_dhcp_answer( buf, plen);
          uint8_t dhcpState = es.ES_dhcp_state();
          
          if( dhcpState != DHCP_STATE_OK && !gotIp && ( fastDhcpRequest < lastDhcpRequest + 1000L * 150 ) ) {
            if ( millis() > ( lastDhcpRequest + 10000L ) ) {
              lastDhcpRequest = millis();
              
              // DHCP Request Packet
              DEBUG_PRINTLN("DHCP Discover..."); // debug print
              if( es.allocateIPAddress(buf, BUFFER_SIZE, mac_address, MYWWWPORT, ip_address, netmask, gw_addrsss, dhcpsvrip, dns_address ) < 0 ) {
                DEBUG_PRINTLN("Failed to get IP address");
                delay( 200 );
              }
              continue;
            }
          } else {
            if( !gotIp ) {
              if ( dhcpState != DHCP_STATE_OK ) {
                DEBUG_PRINTLN("DHCP NonResponse"); // debug print
              }
              
              // Display the results:
              DEBUG_PRINT("IP Address:"); // debug print
              ip2str( strbuf, ip_address );
              DEBUG_PRINTLN( strbuf ); // debug print
              if ( !TimeKeep || millis() < 30000L ) {
                lc.setChar( 0, 3, ' ', true ); // InitialIndicater
                delay( 500 );
              }
              DEBUG_PRINT("Netmask:"); // debug print
              ip2str( strbuf, netmask );
              DEBUG_PRINTLN( strbuf ); // debug print
              if ( !TimeKeep || millis() < 30000L ) {
                delay( 500 );
              }
              DEBUG_PRINT("DefaultGateway:"); // debug print
              ip2str( strbuf, gw_addrsss );
              DEBUG_PRINTLN( strbuf ); // debug print
              if ( !TimeKeep || millis() < 30000L ) {
                delay( 500 );
              }
              
              DEBUG_PRINT("DNS IP:"); // debug print
              ip2str( strbuf, dns_address );
              DEBUG_PRINTLN( strbuf ); // debug print
              if ( !TimeKeep || millis() < 30000L ) {
                lc.setChar( 0, 4, ' ', true ); // InitialIndicater
                delay( 1500 );
              }
              
              // Setup IP Address:
              es.ES_init_ip_arp_udp_tcp(mac_address, ip_address, MYWWWPORT);
              es.ES_client_set_gwip(gw_addrsss);
              es.ES_dnslkup_set_dnsip(dns_address);
              DEBUG_PRINTLN("DHCP IP-Set..."); // debug print
              
              // IP-Display
              if ( !TimeKeep || millis() < 30000L ) ipscrollDigits(ip_address);
              
              lcd_needs_update=99;
              gotIp = true;
            }
            if ( ( millis() / 1000 ) % ( 60 * DHCP_POL_INTERVAL ) == 0 ) {
              
              DEBUG_PRINTLN("DHCP Status Reset");
              fastDhcpRequest = millis();
              lastDhcpRequest = fastDhcpRequest;
              dhcpState = 0;
              gotIp = false;
            }
          }
        } else {
          // IP-Display
          if ( !TimeKeep || millis() < 30000L ) ipscrollDigits(ip_address);
          lcd_needs_update=99;
          gotIp = true;
        }
      }
      
      // DNS Section
      if ( dns_state == 0 ){
        lastDnsRequest = millis();
        es.ES_dnslkup_request(buf, (uint8_t*)dnsreqesthost );
        DEBUG_PRINTLN("DNS Wait...");
        dns_state = 1;
        continue;
      }
      if ( dns_state == 1 && es.ES_udp_client_check_for_dns_answer( buf, plen ) ){
        uint8_t *websrvipptr = &ntp_polling_address[0];
        websrvipptr = es.ES_dnslkup_getip();
        DEBUG_PRINTLN("DNS Answer...");
        for( int8_t on = 0; on < 4; on++ ) {
          ntp_polling_address[on] = *websrvipptr++;
        }
        //eeprom_busy_wait();
        //eeprom_write_byte((uint8_t *)0x0, 60); // magic number
        eeprom_write_block((uint8_t *)ntp_polling_address, (void *)21, sizeof(ntp_polling_address));
        dns_state = 2;
        continue;
      }
      
      // RGB LED Section
      if ( LED_mode != 0 ) { // Lighting Off
      
        uint16_t Hsv = 0;
        
        if ( nextLEDChange < millis() ) { // Check for updates
          switch ( LED_mode ) {
            case 1: // RandomChange
              //Serial.println("RandomChange"); // Debug Print
              hsv_rgb(random(361),cMap);
              Red = cMap[0];
              Green = cMap[1];
              Blue = cMap[2];
              nextLEDChange = millis() + 500 * ( RGB_change_speed + 1 ); // The next update time setting
              break;
               
            case 2: // Circulation
              //Serial.println("Circulation"); // Debug Print
              if ( Hsv < 360 ) {
                Hsv++;
              } else {
                Hsv = 0;
              }
              hsv_rgb(Hsv,cMap);
              Red = cMap[0];
              Green = cMap[1];
              Blue = cMap[2];
              nextLEDChange = millis() + 200 * ( RGB_change_speed + 1 ); // The next update time setting
              break;
              
            case 3: // Temperature(DS18B20)
              //Serial.println("Temperature"); // Debug Print
              tempCsum+= ReadTemp() * TEMP_SENSOR_OFFSET; // Measurements to calculate the total average value
              tmpReadcount++;
              nextLEDChange = millis() + 750; // The next update time setting
              break;
              
            default: // Specified color
              //Serial.println("SelectRGB"); // Debug Print  
              Red = LED_red;   // Red_LED ChangeColorSet
              Green = LED_green;// Green_LED ChangeColorSet
              Blue = LED_blue;  // Blue_LED ChangeColorSet
              nextLEDChange = millis() + 3000; // // The next update time setting   
          }
        // Change the value to set the RGB-LED
        analogWrite(LED_PIN_RED, Red);
        analogWrite(LED_PIN_GREEN, Green);
        analogWrite(LED_PIN_BLUE, Blue);
        }
        //Serial.println("Change RGB-LED"); // Debug Print
      } else {
        // Turn off the RGB-LED
        analogWrite(LED_PIN_RED, 0); 
        analogWrite(LED_PIN_GREEN, 0); 
        analogWrite(LED_PIN_BLUE, 0); 
        //Serial.println("RGB-LED ALL-Off"); // Debug Print
      }
      
      // Repeat every second section(1second) //
      if ( lcd_needs_update ) {
        //Serial.println( (int)lcd_needs_update ); // debug print
        
        // The Temperature sensor is acquired.
        reading_t_sensor = ReadTemp() * TEMP_SENSOR_OFFSET;
        
        // The voltage of the sensor(S9648-100) is acquired. 
        int reading_p_sensor = analogRead(PHOTO_SENSOR);
        
        //float voltage = ((long)reading * 5000) / 1024; // AD => mV Conversion
        //float microamp = (voltage * 1000) / 1000; // The voltage is converted into the current. I=E/R (R=1000);
        //float lx = microamp / (290 / 100); // The current is converted into lux. 
        avglx[lx_in] = ( ( (long)reading_p_sensor * 5000 ) / 1024 * 1000 ) / 1000 / ( 290 / 100 );
        
        // Debug Print
        //Serial.print(voltage);
        //Serial.println(" mV, ");
        //Serial.print(microamp);  
        //Serial.println(" uA, ");
        //Serial.print(avglx[lx_in]);
        //Serial.println(" Avg_lx");
        
        lx_in++;
        
        if ( lx_in > 7) lx_in = 0;
        
        int lx;
        for ( int i = 0; i < 7; i++ ) {
          lx = lx + (int)avglx[i];
        }
        // Debug Print
        //Serial.print(lx);
        //Serial.println(" Sum_lx");
        
        lx = lx / 8;
        
        // Debug Print
        //Serial.print(lx);
        //Serial.println(" lx");
        
        // Night mode decision
        boolean night_mode_flag = false;
        
        if ( night_mode ) {
          if ( day_time_start < day_time_end ) {
            if ( ( now_min / 60 ) > day_time_start && ( now_min / 60 ) > day_time_end ) {
              night_mode_flag = true;
              //Serial.println("DayMode1"); // debug print
            } else {
              //Serial.println("NightMode1"); // debug print
            }
          } else {
            if ( ( now_min / 60 ) >= day_time_end ) {
              if ( ( now_min / 60 ) > day_time_start && ( now_min / 60 ) < day_time_end ) {
                night_mode_flag = true;
                //Serial.println("DayMode2"); // debug print
              } else {
              //Serial.println("NightMode2"); // debug print
              }
            } else {
              if ( ( now_min / 60 ) < day_time_start && ( now_min / 60 ) > day_time_end ) {
                night_mode_flag = true;
                //Serial.println("DayMode3"); // debug print
              } else {
              //Serial.println("NightMode3"); // debug print
              }
            }
          }
        } else {
          night_mode_flag = false;
          //Serial.println("NightModeOff"); // debug print
        }
        
        // Dimmer condition is judged. 
        if ( lx <= 150 && dimmer ) {
          if ( !night_mode_flag ) {
            led_bri = day_brightness - DIMMER_DOWN;
          } else {
            led_bri = night_brightness - DIMMER_DOWN;
          }
          if ( led_bri <= 0 ) {
            led_bri = 1;
          }
          //Serial.println("Dimmer On"); // debug print
        } else {
          if ( !night_mode_flag ) {
            led_bri = day_brightness;
          } else {
            led_bri = night_brightness;
          }
          //Serial.println("Dimmer Off"); // debug print
        }
        
        // Display Shutdown mode
        if ( !clock_disp || ( day_brightness == 0 && !night_mode_flag ) || ( night_brightness == 0 && night_mode_flag ) ) {
          lc.shutdown( 0, true );
          //Serial.println("DisplayShutdown"); // debug print
        } else {
          lc.shutdown( 0, false );
          lc.setIntensity( 0, led_bri );
        }
        //Serial.print("Brightness"); // debug print
        //Serial.println("led_bri"); // debug print
        
        // From the RGB color space specified by the temperature.
        if ( LED_mode != 0 && LED_mode == 3 && tmpReadcount > 30 * ( RGB_change_speed + 1 ) ) {
          tempC = tempCsum / ( tmpReadcount );// + 0.5; // Calculate the average
          tempC = constrain(tempC, tempMin, tempMax) * 10; // Check the position in the display range
          cVal = map(tempC, tempMin *10, tempMax *10, 300, 0); // Converted to HSV
          hsv_rgb(cVal,cMap); // HSV to RGB conversion
          Red = cMap[0];
          Green = cMap[1];
          Blue = cMap[2];
          
          // Debug Print
          DEBUG_PRINT("AverageTemp: ");
          DEBUG_PRINT(tempC / 10);
          DEBUG_PRINT(",  cVal: ");
          DEBUG_PRINT(cVal);
          DEBUG_PRINT(",  RGB: ");
          DEBUG_PRINT((int)Red);
          DEBUG_PRINT(",");
          DEBUG_PRINT((int)Green);
          DEBUG_PRINT(",");
          DEBUG_PRINTLN((int)Blue);
          
          tempC = 0;
          tempCsum = 0;
          tmpReadcount = 0;
        }
        
        if ( es.ES_enc28j60linkup() ) {
        //if ( es.ES_enc28j60linkup() && network ) {
          
          if ( ntp && gotIp ) {
            
            // have link but no up-to date ntp answer
            if ( haveNTPanswer == 2 ) {
              //DEBUG_PRINTLN("NTP Wait..."); // debug print
            }
            if ( lcd_needs_update > 3 && dns_state != 1 ) { // 3 seconds
            
              if ( ( haveNTPanswer == 0 && millis() < (10000L * 25 ) ) || lcd_needs_update > 127 ) {

                int Num;
                
                ntpclientportL++;
                lcd_needs_update = 0;
                
                // LED NTP Wait...
                if ( Num < 5 ) {
                  Num++;
                } else {
                  Num = 0;
                  lc.clearDisplay( 0 );
                }
                
                // Waiting lindicator
                //Serial.println( (int)lcd_needs_update ); // debug print
                if ( lcd_needs_update < 127 ) {
                  lc.setChar( 0, Num, '_', false ); //lc.setRow( 0, Num, B00001000 );
                }
                
                // DelayCalculation
                ntp_response_delay = micros(); // Tc1
                
                // NTP Request Packet
                DEBUG_PRINTLN("NTP Request3..."); // debug print
                es.ES_client_ntp_request(buf, ntp_polling_address, ntpclientportL);
                
                NTP_LED_WaitFlag = true;
                continue;
                
              } else if ( lcd_needs_update != 99 ) {
                DEBUG_PRINTLN("NTP TimeOut"); // debug print
                digitalWrite( NTP_LED, LOW );
                haveNTPanswer = 9;
              }
            }
          }
        } else {
          haveNTPanswer = 9;
        }
        
        // link up or link down
        if ( haveNTPanswer > 0 || lcd_needs_update == 99 ) {
          if ( !SET_MODE ) {
            if ( TimeKeep ) {
              
              // Data & Time Display is generated
              DateTime now = RTC.now(); // RTC Getting Time
              uint8_t tmp_hour = now.hour();
              uint8_t tmp_min = now.minute();
              uint8_t tmp_sec = now.second();
              
              sprintf_P( date, PSTR("%02u%02u%02u"), now.year() % 100, now.month(), now.day() );
              sprintf_P( clock, PSTR("%02u%02u%02u"), hol_hour, tmp_min, tmp_sec );
              
              now_min = tmp_hour * 60 + tmp_min;
              
              // Return Time Trigger
              if ( ( tmp_sec % date_disp_sec ) == 0 && date_disp_sec != 60 ) {
                SEL_CAT = false;
              }
              
              // Update 7Seg display Clock(Time)
              if ( !SEL_CAT ) {
                if ( ampm && tmp_hour >= 12 ) {
                  hol_hour = tmp_hour - 12;
                  lc.setChar( 0, 7, '_', false ); // lc.setRow( 0, 7, B00001000 ); // AM
                } else {
                  hol_hour = tmp_hour;
                  if ( ampm ) {
                    lc.setChar( 0, 7, '~', false ); // lc.setRow( 0, 7, B01000000 ); // PM
                  } else {
                    lc.setChar( 0, 7, ' ', false );
                  }
                }
                uint8_t led_deg = 5;
                
                for ( uint8_t i = 0; i < 6; i++ ) {
                  lc.setChar( 0, led_deg, clock[i], linkstatus[led_deg] );
                  led_deg--;
                }
                //Serial.println( clock ); // debug print
              }
              
              if ( prev_min != now_min || lcd_needs_update == 99 ) { // 1 minutes //
              
                // Date Display Trigger
                if ( date_disp_int != 0) {
                  if ( ( now_min % date_disp_int ) == 0 && date_disp_sec <= 60 ) {
                    SEL_CAT = true;
                  }
                } else if ( now_min ==0 && date_disp_int == 1440 ) {
                  SEL_CAT = true;
                }
                
                // Update 7Seg display Date
                if ( SEL_CAT ) {
                  uint8_t led_deg = 5;
                  for ( uint8_t i = 0; i < 6; i++ ) {
                    lc.setChar( 0, led_deg, date[i], linkstatus[led_deg] );
                    led_deg--;
                  }
                  lc.setChar( 0, 7, '=', false );  // AM/PM Lighting
                  //Serial.println( date ); // debug print
                }
              }
            } else {
              for ( uint8_t i = 0; i < 6; i++ ) {
                lc.setChar( 0, i, pgm_read_byte( & (wait_abbrev[led_num])), false );
              }
              if ( led_num < 5 ) {
                led_num++;
              } else {
                led_num = 0;
              }
              DEBUG_PRINTLN("LostTime");
              
              if ( es.ES_enc28j60linkup() ) { 
                // DelayCalculation
                ntp_response_delay = micros(); // Tc1
                
                // NTP Request Packet
                ntpclientportL++;
                DEBUG_PRINTLN("NTP Request..."); // debug print
                es.ES_client_ntp_request(buf, ntp_polling_address, ntpclientportL);
              }
            }
            
            // NTP Update Trigger
            if ( ( ( now_min + 1 ) % ntp_interval ) == 0 && ntp ) {
              // mark that we will wait for new ntp update
              //DEBUG_PRINTLN("NTP Trigger..."); // debug print
              NTP_LED_WaitFlag = true;
              haveNTPanswer = 2;
            }
            
            // NTP Update Request
            if ( ( now_min % ntp_interval ) == 0 && haveNTPanswer == 2 && ntp ) {
              if ( haveNTPanswer != 9 ) {
                
                // DelayCalculation
                ntp_response_delay = micros(); // Tc1
                
                // NTP Request Packet
                ntpclientportL++;
                DEBUG_PRINTLN("NTP Request..."); // debug print
                es.ES_client_ntp_request(buf, ntp_polling_address, ntpclientportL);
              }
              // ask only once in the request
              haveNTPanswer = 3;
            }
            prev_min = now_min;
          }
          lcd_needs_update = 0;
        }
      }
      continue;
    } else {
      if ( dns_state==1 && es.ES_udp_client_check_for_dns_answer( buf, plen ) ){
        uint8_t *websrvipptr = &ntp_polling_address[0];
        websrvipptr = es.ES_dnslkup_getip();
        DEBUG_PRINTLN("DNS Answer...");
        for( int8_t on = 0; on < 4; on++ ) {
          ntp_polling_address[on] = *websrvipptr++;
        }
        //eeprom_busy_wait();
        //eeprom_write_byte((uint8_t *)0x0, 60); // magic number
        eeprom_write_block((uint8_t *)ntp_polling_address, (void *)21, sizeof(ntp_polling_address));
        dns_state=2;
        continue;
      }
    }
    
    // udp start, src port must be 123 (0x7b):
    if (buf[IP_PROTO_P] == IP_PROTO_UDP_V && buf[UDP_SRC_PORT_H_P] == 0 && buf[UDP_SRC_PORT_L_P] == 0x7b) {
      
      // NTP Time Delay Calculation Use
      int8_t offset_sec;
      uint32_t Ts1, Ts2;
      float Ts1p, Ts2p;
      
      boolean NTP_Packet = true; // AnalyzeDataFlag
      
      // judge packet
      if ( ntpclientportL ) {
        
        if ( buf[UDP_DST_PORT_L_P] != ntpclientportL ) { 
          NTP_Packet = false; // not ntp packet
        }
        if ( buf[UDP_LEN_H_P] != 0 || buf[UDP_LEN_L_P] != 56 || buf[UDP_SRC_PORT_L_P] != 0x7b ) {
          NTP_Packet = false; // not ntp packet
        
        }
      }
      if ( NTP_Packet ) {
        
        DEBUG_PRINTLN("NTP Answer..."); // debug print
        
        // NTP DelayCalculation
        ntp_response_delay = micros() - ntp_response_delay; // Tc2-Tc1
        
        // CodeDelay DelayCalculate
        long code_delay = micros(); // CodeDelayCalc(DebugUse)
        
        // NTP TimeDelayCalculation
        // *Originate Time Stamp:Tc1
        // *Respons Time Stamp  :Tc2
        // *Receive Time Stamp  :Ts1
        // *Transmit Time Stamp :Ts2
        //
        // SendDelayTime : (Tc2-Tc1)-((Ts1-Ts2)+(Ts2p-Ts1p))
        // 1-Way SendDelayTime : (Tc2-Tc1)-((Ts1-Ts2)+(Ts2p-Ts1p)/2
        // Client TimeDelay : ((Ts2-Ts1)+(Ts1p-Ts2p))/2-(Tc2-Tc1)/2
        
        // Ts1,Ts1p,Ts2,Ts2p PacketDataInput
        Ts1 = ((uint32_t)buf[0x4A]<<24)|((uint32_t)buf[0x4B]<<16)|((uint32_t)buf[0x4C]<<8)|((uint32_t)buf[0x4D]);
        Ts2 = ((uint32_t)buf[0x52]<<24)|((uint32_t)buf[0x53]<<16)|((uint32_t)buf[0x54]<<8)|((uint32_t)buf[0x55]);
        Ts1p = ((uint32_t)buf[0x4E]<<24)|((uint32_t)buf[0x4F]<<16)|((uint32_t)buf[0x50]<<8)|((uint32_t)buf[0x51]);
        Ts2p = ((uint32_t)buf[0x56]<<24)|((uint32_t)buf[0x57]<<16)|((uint32_t)buf[0x58]<<8)|((uint32_t)buf[0x59]);
        uint32_t Ts1pi = Ts1p / 4294967296.0 * 1000 * 1000;  // Decimal point
        uint32_t Ts2pi = Ts2p / 4294967296.0 * 1000 * 1000;  // Decimal point
        ntp_response_delay = (ntp_response_delay - ( ( ( Ts2 - Ts1 ) * 1000 * 1000 ) + ( Ts2pi - Ts1pi ) ) ) / 2; // microseconds(Ts2 - Ts1)
        
        /* DebugPrint*/
        Serial.print("Ts1:");
        Serial.println(Ts1);
        Serial.print("Ts2:");
        Serial.println(Ts2);
        Serial.print("Ts1pi:");
        Serial.println(Ts1pi);
        Serial.print("Ts2pi:");
        Serial.println(Ts2pi);
        Serial.print("NTP ResponseTimeDelay:");
        Serial.println( ntp_response_delay );
        
        DateTime prev_now = RTC.now(); // RTC Getting Time
        int32_t prev_utime = (int32_t)prev_now.unixtime(); // UnixTime
        
        // convert to unix time:
        if ( ( Ts2 & 0x80000000UL ) == 0 ) {
          // Set current time(7-Feb-2036 @ 06:28:16 UTC it will wra)
          gt_time = Ts2 + TIMEOFDAY_TO_NTP_OFFSET_2036;
        } else {
          // Set current time(from now until 2036)
          gt_time = Ts2 - TIMEOFDAY_TO_NTP_OFFSET;
        }
        // CodeDelay DelayCalculate
        //Serial.print("ProcessingTime(us):");
        //Serial.println( micros() - code_delay );
        
        // Time OffsetCalculate
        long offset_cal_val = Ts2pi + ntp_response_delay + ( micros() - code_delay ) + RTC_INIT_TIME;
        if( offset_cal_val <= 1000000 ) { offset_sec = 1; } else { offset_sec = 2; } //(DS1307 64 x 8, Serial, I2C Real-Time Clock)
        //if( offset_cal_val <= 1000000 ) { offset_sec = 0; } else { offset_sec = 1; } //(RTC-8564 JE/NB I2C Real-Time Clock)
        
        // Time Set
        delay( 1000 - ( offset_cal_val / 1000 ) % 1000 );
        RTC.adjust(DateTime( (int32_t)gt_time + (int32_t)360 * (int32_t)hours_offset_to_utc + (int32_t)offset_sec ) );
        
        /* DebugPrint*/
        DateTime now = RTC.now(); // RTC Getting Time
        DEBUG_PRINT("UTC:");
        DEBUG_PRINTLN( (int32_t)gt_time );
        DEBUG_PRINT("Hours Offset:");
        DEBUG_PRINTLN( hours_offset_to_utc );
        DEBUG_PRINT("Local:");
        DEBUG_PRINTLN( (int32_t)gt_time + (int32_t)360 * (int32_t)hours_offset_to_utc );
        DEBUG_PRINT("ClokStart Delay(ms):");
        DEBUG_PRINTLN( 1000 - ( offset_cal_val / 1000 ) % 1000 );
        DEBUG_PRINT("OffcetCalTime:");
        DEBUG_PRINTLN( offset_cal_val );
        DEBUG_PRINT("Setup TimeOffset:");
        DEBUG_PRINTLN( offset_sec );
        DEBUG_PRINT("Adjustment_ms:");
        DEBUG_PRINTLN((int)( ( (int32_t)now.unixtime() - (int32_t)prev_utime) * 1000 + (int)( (int32_t)Ts1pi - (int32_t)ntp_response_delay) / 1000 ) - offset_sec * 1000 );
        
        /* DebugPrint*/
        /*DEBUG_PRINT((int16_t)now.year());
        DEBUG_PRINT('/');
        DEBUG_PRINT((int8_t)now.month());
        DEBUG_PRINT('/');
        DEBUG_PRINT((int8_t)now.day());
        DEBUG_PRINT(' ');
        DEBUG_PRINT((int8_t)now.hour());
        DEBUG_PRINT(':');
        DEBUG_PRINT((int8_t)now.minute());
        DEBUG_PRINT(':');
        DEBUG_PRINTLN((int8_t)now.second());
        Serial.print('(');
        for ( int8_t i = 0; i < 3; i++ ) {
          dstr[i] = pgm_read_byte( & (day_abbrev[(RTC.dayOfWeek()) * 3 + i]));
        }
        dstr[3] = '\0';
        DEBUG_PRINT( dstr );
        DEBUG_PRINTLN(')');*/
        
        lcd_needs_update = 99;
        haveNTPanswer = 1;
        
        NTP_LED_WaitFlag = false;
        NTP_Packet = false;
        TimeKeep = true;
        
        digitalWrite( NTP_LED, HIGH );
      }
      continue;
    }
    
    // tcp port 80 begin
    if (strncmp("GET ", (char *) & (buf[dat_p]), 4) != 0) {
      // head, post and other methods:
      plen=es.ES_fill_tcp_data_p(buf,0,strHttpHeader);
      plen=es.ES_fill_tcp_data_p(buf,plen,strPageHeader);
      plen=es.ES_fill_tcp_data_p(buf,dat_p,PSTR("<h1>200 OK</h1>\n"));
      plen=es.ES_fill_tcp_data_p(buf,plen,strPageFooter);
      goto SENDTCP;
    }
    if (strncmp("/ ", (char *) & (buf[dat_p+4]), 2) == 0) {
      plen=es.ES_fill_tcp_data_p(buf,0,strhtmlPageHeader);
      plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlPageTitle);
      plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<body>\n<h1><font color=#000099>Arduino 7SegLED/RTC/NTP Clock</font></h1>\n<hr><b>"));
      if (haveNTPanswer) {
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Date&Time : <h2><font color=#000033>\n&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp"));
        DateTime now = RTC.now();  // RTC Getting Time
        for ( int8_t i = 0; i < 3; i++ ) {
          dstr[i] = pgm_read_byte( & (day_abbrev[(now.dayOfWeek()) * 3 + i])); 
        }
        dstr[3] = '\0';
        sprintf_P(date, PSTR("%02u/%02u/%02u-%s"), now.year(), now.month(), now.day(), dstr);
        plen=es.ES_fill_tcp_data(buf,plen,date);
        plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("\n&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp\n"));
        uint8_t tmp_hour = now.hour();
        for ( uint8_t i = 0; i < 2; i++ ) {
          if ( ampm ) {
            dstr[i] = pgm_read_byte( & (ampm_abbrev[tmp_hour / 12 * 2 + i]));
          } else {
            dstr[i] = ' ';
          }
        }
        dstr[2] = '\0';
        if ( ampm && tmp_hour >= 12 ) {
          hol_hour = tmp_hour - 12;
        } else {
          hol_hour = tmp_hour;
        }
        sprintf_P(clock, PSTR("%s %02u:%02u:%02u"), dstr, hol_hour, now.minute(), now.second());
        plen=es.ES_fill_tcp_data(buf,plen,clock);
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" (UTC "));
        if (hours_offset_to_utc >= 0) {
          plen=es.ES_fill_tcp_data(buf,plen,"+");
        }
        itoa(hours_offset_to_utc,dstr,10);
        adddotifneeded(dstr);
        plen=es.ES_fill_tcp_data(buf,plen,dstr);
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(")</font></h2>"));
        plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Thermometer : <h2><font color=#000033>\n&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp&nbsp"));
        int16_t celsius;
        if (cefa) {
          celsius = reading_t_sensor * 100;
        } else {
          celsius = ( reading_t_sensor * 1.8 + 32.0 ) * 100;
        }
        sprintf_P(dstr, PSTR("%+2d.%02u"), celsius/100, celsius%100);
        plen=es.ES_fill_tcp_data(buf,plen,dstr);
        if (cefa) {
          plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("C"));
        } else {
          plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("F"));
        }
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("</font></h2></b><br>"));
        if (haveNTPanswer > 1 or NTP_LED_WaitFlag) {
          plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<i><font color=#FF0000>&nbsp*Last ntp sync is older than "));
          itoa(ntp_interval,strbuf,10);
          plen=es.ES_fill_tcp_data(buf,plen,strbuf);
          plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("minute</font></i><br>\n"));
        }
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("\n<a href=\"./\">refresh</a>\n"));
      } else {
        plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<i><h2><font color=#FF0000>&nbsp*Waiting for NTP answer...</font></h2></i><br>\n<a href=\"./\">refresh</a>"));
      }
      plen=es.ES_fill_tcp_data_p(buf,plen,strPageFooter);
      goto SENDTCP;
    }
    
    cmd = analyse_get_url((char *) & (buf[dat_p+5]));
    
    // return values:  10,21-26 just display current settings
    //                 95 values error
    //                 99 values upated
    if(cmd == -1) {
      plen=es.ES_fill_tcp_data_p(buf,0,PSTR("HTTP/1.0 404 Not Found\r\nContent-Type: text/html\r\n\r\n"));
      plen=es.ES_fill_tcp_data_p(buf,plen,strPageHeader);
      plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<h1>File Not Found</h1>"));
      plen=es.ES_fill_tcp_data_p(buf,plen,strPageFooter);
      goto SENDTCP;
    }
    if(cmd == 10) {
      // All configuration&information display
      plen=print_webpage0(buf);
      goto SENDTCP;
    }
    if(cmd == 21) {
      // Time preference page
      plen=print_webpage21(buf);
      goto SENDTCP;
    }
    if(cmd == 22) {
      // Date preference page
      plen=print_webpage22(buf);
      goto SENDTCP;
    }
    if(cmd == 23) {
      // Display configuration page
      plen=print_webpage23(buf);
      goto SENDTCP;
    }
    if(cmd == 24) {
      // Network configuration page
      plen=print_webpage24(buf);
      goto SENDTCP;
    }
    if(cmd == 25) {
      // NTP configuration page
      plen=print_webpage25(buf);
      goto SENDTCP;
    }
    if(cmd == 26) {
      // Environment configuration page
      plen=print_webpage26(buf);
      goto SENDTCP;
    }
    if(cmd == 27) {
      // LED configuration page
      plen=print_webpage27(buf);
      goto SENDTCP;
    }
    if (cmd == 95) {
      // Configuration Error
      plen=es.ES_fill_tcp_data_p(buf,0,strHttpHeader);
      plen=es.ES_fill_tcp_data_p(buf,plen,strPageHeader);
      plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<p>Error, Values Checking.<br><a href=\"/config\">continue</a></p>\n"));
      plen=es.ES_fill_tcp_data_p(buf,plen,strPageFooter);
      goto SENDTCP;
    }
    if (cmd == 99) {
      // Configuration Comit
      plen=es.ES_fill_tcp_data_p(buf,0,strHttpHeader);
      plen=es.ES_fill_tcp_data_p(buf,plen,strPageHeader);
      plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<p>OK, Values Updated.<br><a href=\"/config\">continue</a></p>\n"));
      plen=es.ES_fill_tcp_data_p(buf,plen,strPageFooter);
      goto SENDTCP;
    }
    
    // do bit to re-get network details
    continue;
    
SENDTCP:
    es.ES_www_server_reply(buf, plen); // send web page data
    // tcp port 80 end

  }
}
// The end
