// prepare the webpage by writing the data to the tcp send buffer
// Note that this is about as much as you can put on a html page.
// If you plan to build additional functions into this clock (e.g alarm clock) then
// add a new page under /alarm and do not expand this /config page.
uint16_t print_webpage0(uint8_t *buf)
{
  uint16_t plen;
  plen=es.ES_fill_tcp_data_p(buf,0,strHttpHeader); // HttpHeader
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlPageHeader); // PageHeader
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlPageTitle); // PageTitle
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlPageHeader2); // PageHeader2
  
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Arduino NTP_Clock SettingDisplay"));// PageName
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("</h1></center>\n<hr><br>\n<center>\n<table border=1 width=500 cellspacing=0 cellpadding=5 bordercolor=#333333>"));
  
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("\n<tr><td>\n<b><a href=\"../link_tim\">Time</a></b><br>\n"));
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("*Clock Display : "));
  if (clock_disp) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("On"));
  } else {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Off"));
  }
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbsp12H/24H : "));
  if (ampm) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("12H"));
  } else {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("24H"));
  }
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspColon : "));
  if (colon_disp > 1) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Lighting"));
  } else if (colon_disp == 1) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Blinking"));
  } else if (colon_disp < 1) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Off"));
  }
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br><b><a href=\"../link_dat\">\nDate</a></b><br>"));
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspInterval : "));
  itoa(date_disp_int,strbuf,10);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" Min"));
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspDispSec : "));
  itoa(date_disp_sec,strbuf,10);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" Sec"));
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br><b><a href=\"../link_dis\">Display</a></b><br>"));
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspDimmer : "));
  if (dimmer) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("On"));
  } else {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Off"));
  }
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspDayTime : "));
  itoa(day_time_start,strbuf,10);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" to "));
  itoa(day_time_end,strbuf,10);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspNightMode : "));
  if (night_mode) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("On"));
  } else {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Off"));
  }
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspBrightness(0-15)  Day: "));
  itoa(day_brightness,strbuf,10);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" Night: "));
  itoa(night_brightness,strbuf,10);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("</td>\n<td>"));
  
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<b><a href=\"../link_net\">Network</b></A><br>"));
  /*plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("\n*Network : "));
  if (es.ES_enc28j60linkup()) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("LinkUp"));
  } else {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("LinkDown"));
  }
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>*/
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("*DHCP : "));
  if (dhcp) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("On"));
  } else {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Off"));
  }
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspIP_Address : "));
  ip2str(strbuf,ip_address);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspSubnetMask : "));
  ip2str(strbuf,netmask);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspDefaultGateway : "));
  ip2str(strbuf,gw_addrsss);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspDNS Server : "));
  ip2str(strbuf,dns_address);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<br><b><a href=\"../link_ntp\">NTP</a></b><br>"));
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("\n*NTP : "));
  if (ntp) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("On"));
  } else {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Off"));
  }
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspNTP server IP : "));
  ip2str(strbuf,ntp_polling_address);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspUpdate interval : "));
  itoa(ntp_interval,strbuf,10);
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" minutes"));
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspOffset to UTC : "));
  if (hours_offset_to_utc >= 0) {
    strbuf[0]='+';
  }
  itoa(hours_offset_to_utc,&(strbuf[1]),10);
  adddotifneeded(&(strbuf[1]));
  plen=es.ES_fill_tcp_data(buf,plen,strbuf);
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("</td>\n</tr>"));
  
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("\n<tr><td colspan=2>"));
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("\n<b><a href=\"../link_env\">Environment</a></b>"));
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspTemperature : "));
  if (cefa) {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Celsius"));
  } else {
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("Fahrenheit"));
  }
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
  
 int in = digitalRead(LED_ENA);
 if( in==LOW ){
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("<b><a href=\"../link_led\">LED</a></b>"));
    plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspSelectRGB  R:"));
    itoa(LED_red,strbuf,10);
    plen=es.ES_fill_tcp_data(buf,plen,strbuf);
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" G:"));
    itoa(LED_green,strbuf,10);
    plen=es.ES_fill_tcp_data(buf,plen,strbuf);
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR(" B:"));
    itoa(LED_blue,strbuf,10);
    plen=es.ES_fill_tcp_data(buf,plen,strbuf);
    plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
    
    static char lstr[12];
    static const char led_mode[] PROGMEM = "Lighting OffRandomChangeCirculation Temperature SelectingRGB";
    
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspLED Lighting : "));
    for ( uint8_t m = 0; m < 12; m++ ) {
      lstr[m] = pgm_read_byte( & ( led_mode[LED_mode + m + 11 * LED_mode]));
    }
    lstr[12] = '\0';
    plen=es.ES_fill_tcp_data(buf,plen,lstr);
    plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
    
    static const char led_speed[] PROGMEM = "FastSpeedSlowSpeed";
    plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("&nbspChangeSpeed : "));
    for ( uint8_t m = 0; m < 9; m++ ) {
      lstr[m] = pgm_read_byte( & ( led_speed[RGB_change_speed + m + 8 * RGB_change_speed]));
    }
    lstr[9] = '\0';
    plen=es.ES_fill_tcp_data(buf,plen,lstr);
    plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlbr); // <br>
 }
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("</td>\n</tr>\n</table><br>\n<hr>\n</center>"));
  plen=es.ES_fill_tcp_data_p(buf,plen,PSTR("\n<a href=\"../\"><i>=> Clock display</i></a>\n"));
  plen=es.ES_fill_tcp_data_p(buf,plen,strhtmlPageFooter); // PageFooter
  
  return(plen);
}
